import Anki, { IMedia } from "ankisync";
import { R2rOnline, ICondOptions, IEntry, IPagedOutput, IRender, R2rLocal, IProgress } from "@rep2recall/r2r-format";
export default class R2rMongo extends R2rOnline {
    private user?;
    build(): Promise<this>;
    signup(email: string): Promise<string>;
    getSecret(): Promise<string | null>;
    newSecret(): Promise<string | null>;
    login(email: string, secret: string): Promise<boolean>;
    logout(): Promise<boolean>;
    close(): Promise<this>;
    reset(): Promise<this>;
    parseCond(q: string, options?: ICondOptions<IEntry>): Promise<IPagedOutput<Partial<IEntry>>>;
    insertMany(entries: IEntry[]): Promise<string[]>;
    updateMany(ids: string[], u: Partial<IEntry>): Promise<void>;
    addTags(ids: string[], tags: string[]): Promise<void>;
    removeTags(ids: string[], tags: string[]): Promise<void>;
    deleteMany(ids: string[]): Promise<void>;
    render(cardId: string): Promise<IRender>;
    protected updateSrsLevel(dSrsLevel: number, cardId: string): Promise<void>;
    protected transformCreateOrUpdate(cardId: string | null, u: Partial<IEntry>): Promise<Partial<IEntry>>;
    protected getOrCreateDeck(name: string): Promise<string>;
    protected getData(cardId: string): Promise<Array<{
        key: string;
        value: any;
    }> | null>;
    protected getFront(cardId: string): Promise<string>;
    export(r2r: R2rLocal, q?: string, options?: {
        callback?: (p: IProgress) => void;
    }): Promise<void>;
    getMedia(h: string): Promise<IMedia | null>;
    allMedia(): Promise<IMedia[]>;
    createMedia(m: {
        name: string;
        data: ArrayBuffer;
    }): Promise<string>;
    deleteMedia(h: string): Promise<boolean>;
    fromR2r(r2r: R2rLocal, options?: {
        filename?: string;
        callback?: (p: IProgress) => void;
    }): Promise<void>;
    fromAnki(anki: Anki, options?: {
        filename?: string;
        callback?: (p: {
            text: string;
            current?: number;
            max?: number;
        }) => void;
    }): Promise<void>;
}
